; Assembled with Pelles Macro Assembler Version 6.50.0

include IconFromBin.inc

.data

pIcon:
INCBIN Smiley.bmp

DlgBox  db 'DLGBOX',0


.data?

hInst   dd ?
hIcon   dd ?

.code

start:

    invoke  GetModuleHandle,0
    invoke  DialogBoxParam,eax,ADDR DlgBox,0,ADDR DlgProc,0
    invoke  ExitProcess,eax

DlgProc PROC hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

LOCAL hDC:DWORD
LOCAL ps:PAINTSTRUCT

    .IF uMsg==WM_INITDIALOG

        invoke  CreateIconFromMem,hWnd,ADDR pIcon
        mov     hIcon,eax        

    .ELSEIF uMsg==WM_PAINT
        
        invoke  BeginPaint,hWnd,ADDR ps
        mov     hDC,eax
        invoke  DrawIcon,hDC,180,90,hIcon
        invoke  EndPaint,hWnd, ADDR ps

    .ELSEIF uMsg==WM_CLOSE

        invoke  EndDialog,hWnd,0

    .ELSE

        xor     eax,eax
        ret

    .ENDIF

    mov    eax,1
    ret

DlgProc ENDP


CreateIconFromMem PROC hWnd:DWORD,pBmp:DWORD

LOCAL hDC:DWORD
LOCAL hBmp:DWORD
LOCAL ii:ICONINFO

    invoke  GetDC,hWnd
    test    eax,eax
    jz      @f
    mov     hDC,eax
    mov     edx,pBmp
    lea     ecx,[edx + SIZEOF BITMAPFILEHEADER]  ; start of the BITMAPINFOHEADER header
    mov     eax,BITMAPFILEHEADER.bfOffBits[edx]
    add     edx,eax
    invoke  CreateDIBitmap,hDC,ecx,CBM_INIT,edx,ecx,DIB_RGB_COLORS
    mov     hBmp,eax
    invoke  ReleaseDC,hWnd,hDC

;; Code portion from xandaz
                     
    mov     ii.fIcon,1
    push    hBmp
    pop     ii.hbmMask
    push    hBmp
    pop     ii.hbmColor
    invoke  CreateIconIndirect,ADDR ii
;;

@@: 
    ret

CreateIconFromMem ENDP


END start
